<?xml version='1.0' encoding='UTF-8'?>
<MorpheusModel version="3">
    <Description>
        <Title>RedivModel10DiffnoSym</Title>
        <Details>with differentiation 10% example</Details>
    </Description>
    <Global>
        <Variable symbol="c" value="0.0"/>
        <Variable symbol="cellCycleTime" value="1e20"/>
        <Variable symbol="time_of_birth" value="0.0"/>
        <Variable symbol="p" value="2"/>
        <Variable symbol="progenitor" value="0"/>
        <Variable symbol="volume" value="50"/>
        <Variable symbol="minCellSize" value="25"/>
        <Variable symbol="maxCellSize" value="250"/>
        <Variable symbol="clone" value="0"/>
        <Variable symbol="cc" value="0"/>
    </Global>
    <Space>
        <Lattice class="hexagonal">
            <Size symbol="size" value="1500, 1500, 0"/>
            <BoundaryConditions>
                <Condition boundary="x" type="periodic"/>
                <Condition boundary="y" type="periodic"/>
            </BoundaryConditions>
            <Neighborhood>
                <Order>3</Order>
                <!--    <Disabled>
        <Distance>1</Distance>
    </Disabled>
-->
            </Neighborhood>
        </Lattice>
        <SpaceSymbol symbol="space"/>
    </Space>
    <Time>
        <StartTime value="0"/>
        <StopTime symbol="stoptime" value="3e5"/>
        <TimeSymbol symbol="time"/>
    </Time>
    <CellTypes>
        <CellType class="biological" name="cells">
            <Property symbol="maxCellSize" value="rand_norm(220,50)"/>
            <Property symbol="minCellSize" value="max(volume/2,30)"/>
            <Property symbol="volume" value="(maxCellSize-minCellSize)/(1+exp(-0.0005*((time-time_of_birth)-10000)))+minCellSize"/>
            <Property symbol="p" value="9e-6&#xa;" name="proliferation rate"/>
            <Property symbol="c" value="0" name="color"/>
            <VolumeConstraint target="volume" strength="1"/>
            <SurfaceConstraint target="0.9" mode="aspherity" strength="1"/>
            <System solver="euler" time-step="1.0">
                <Rule symbol-ref="c">
                    <Expression>if( c > 0, c-1, 0)</Expression>
                </Rule>
                <Rule symbol-ref="volume">
                    <Expression>(maxCellSize-minCellSize)/(1+exp(-0.0005*((time-time_of_birth)-10000)))+minCellSize</Expression>
                </Rule>
                <Rule symbol-ref="progenitor">
                    <Expression>if(progenitor == 0,0,progenitor-1)</Expression>
                </Rule>
                <Rule symbol-ref="cc">
                    <Expression>if(progenitor >0, 2, c>0)</Expression>
                </Rule>
            </System>
            <CellDivision daughterID="daughter" write-log="csv" division-plane="random">
                <Condition>p>rand_uni(0,1) and((time-time_of_birth)==0 or ((time-time_of_birth)>cellCycleTime))</Condition>
                <Triggers>
                    <Rule symbol-ref="c" name="color after division">
                        <Expression>1900</Expression>
                    </Rule>
                    <Rule symbol-ref="p">
                        <Expression>if(mother2daughters&lt;0.38,p=1,p=9e-6)
</Expression>
                    </Rule>
                    <Rule symbol-ref="time_of_birth">
                        <Expression>time</Expression>
                    </Rule>
                    <Rule symbol-ref="cellCycleTime">
                        <Expression>(-(ln(rand_uni(0,1)))*85*100)+2215</Expression>
                    </Rule>
                    <!--    <Disabled>
        <Rule symbol-ref="progenitor">
            <Expression>if(daughter ==2 and sym_division >0.9,abs((mother2daughters&lt;0.45)-1)*rint(cellCycleTime),(mother2daughters&lt;0.45)*rint(cellCycleTime))
</Expression>
        </Rule>
    </Disabled>
-->
                    <Rule symbol-ref="minCellSize">
                        <Expression>volume/2</Expression>
                    </Rule>
                    <Rule symbol-ref="maxCellSize">
                        <Expression>rand_norm(220,50)</Expression>
                    </Rule>
                    <!--    <Disabled>
        <Rule symbol-ref="cellCycleTime">
            <Expression>if(daughter==2,rand_norm((-(ln(mother2daughters))*85*100)+2215,300),(-(ln(mother2daughters))*85*100)+2215)</Expression>
        </Rule>
    </Disabled>
-->
                    <Rule symbol-ref="progenitor">
                        <Expression>if(rand_uni(0,1)&lt;0.10,rint(cellCycleTime),0)</Expression>
                    </Rule>
                    <Rule symbol-ref="mother2daughters">
                        <Expression>rand_uni(0,1)</Expression>
                    </Rule>
                    <Rule symbol-ref="m2dProg">
                        <Expression>rand_uni(0,1)</Expression>
                    </Rule>
                </Triggers>
            </CellDivision>
            <CellDeath>
                <Condition>progenitor ==1 or (progenitor >1 and abs((time-time_of_birth)-cellCycleTime) &lt;3 )</Condition>
            </CellDeath>
            <Property symbol="clone" value="rand_uni(1,255)"/>
            <Property symbol="initialId" value="cell.id"/>
            <Property symbol="time_of_birth" value="0.0"/>
            <Property symbol="cellCycleTime" value="(-(ln(rand_uni(0,1)))*85*100)+2215"/>
            <Property symbol="progenitor" value="0.0"/>
            <Property symbol="mother2daughters" value="rand_uni(0,1)"/>
            <Property symbol="sym_division" value="rand_uni(0,1)"/>
            <Property symbol="cc" value="1"/>
            <Property symbol="m2dProg" value="rand_uni(0,1)"/>
        </CellType>
    </CellTypes>
    <CPM>
        <Interaction default="0">
            <Contact type1="cells" type2="cells" value="-4"/>
        </Interaction>
        <MonteCarloSampler stepper="edgelist">
            <MCSDuration value="1.0"/>
            <Neighborhood>
                <Order>2</Order>
            </Neighborhood>
            <MetropolisKinetics temperature="3" yield="0.1"/>
        </MonteCarloSampler>
        <ShapeSurface scaling="norm">
            <Neighborhood>
                <Order>3</Order>
            </Neighborhood>
        </ShapeSurface>
    </CPM>
    <CellPopulations>
        <Population size="1" type="cells">
            <InitCircle mode="random" number-of-cells="500">
                <Dimensions radius="100" center="750,750,0"/>
            </InitCircle>
        </Population>
    </CellPopulations>
    <Analysis>
        <!--    <Disabled>
        <Gnuplotter time-step="200" decorate="false">
            <Terminal name="png"/>
            <Plot>
                <Cells value="c" min="0.0" max="1">
                    <ColorMap>
                        <Color value="1" color="red"/>
                        <Color value="0.0" color="green"/>
                    </ColorMap>
                </Cells>
                <CellLabels symbol-ref="cell.id" fontsize="4"/>
            </Plot>
        </Gnuplotter>
    </Disabled>
-->
        <Logger time-step="100">
            <Input>
                <Symbol symbol-ref="celltype.cells.size"/>
                <Symbol symbol-ref="cell.center.x"/>
                <Symbol symbol-ref="cell.center.y"/>
                <Symbol symbol-ref="cellCycleTime"/>
                <Symbol symbol-ref="progenitor"/>
                <Symbol symbol-ref="cell.volume"/>
                <Symbol symbol-ref="clone"/>
                <!--    <Disabled>
        <Symbol symbol-ref="minCellSize"/>
    </Disabled>
-->
                <!--    <Disabled>
        <Symbol symbol-ref="maxCellSize"/>
    </Disabled>
-->
                <Symbol symbol-ref="p"/>
            </Input>
            <Output>
                <!--    <Disabled>
        <TextOutput/>
    </Disabled>
-->
                <TextOutput/>
            </Output>
            <!--    <Disabled>
        <Plots>
            <Plot log-commands="true" time-step="1000">
                <Style point-size="0.5" grid="true" style="linespoints"/>
                <Terminal terminal="png"/>
                <X-axis minimum="0" maximum="stoptime">
                    <Symbol symbol-ref="time"/>
                </X-axis>
                <Y-axis minimum="0" maximum="100">
                    <Symbol symbol-ref="celltype.cells.size"/>
                </Y-axis>
            </Plot>
        </Plots>
    </Disabled>
-->
        </Logger>
        <Gnuplotter time-step="1200" decorate="false">
            <Plot/>
            <Terminal name="pdf"/>
            <Plot>
                <Cells value="clone"/>
                <CellLabels precision="0" fontsize="3" value="clone" fontcolor="white"/>
            </Plot>
            <Plot>
                <Cells value="cc">
                    <ColorMap>
                        <Color value="1" color="red"/>
                        <Color value="0.0" color="green"/>
                        <Color value="2" color="black"/>
                    </ColorMap>
                </Cells>
                <CellLabels precision="0" fontsize="3" value="clone"/>
            </Plot>
        </Gnuplotter>
        <!--    <Disabled>
        <DependencyGraph format="svg"/>
    </Disabled>
-->
    </Analysis>
</MorpheusModel>
